use crate::asciicast::{Event, Header};

/// Message used by Liveterm for broadcasts
#[derive(Clone, Debug, Serialize, Deserialize)]
pub enum Message {
  ServerHello(ServerHello),
  AsciicastHeader(Header),
  AsciicastEvent(Event),
}

#[derive(Clone, Debug, Serialize, Deserialize)]
pub struct ServerHello {
  pub url: String,
}

#[test]
fn test() {
  use crate::asciicast::EventKind;

  const msg: &'static str = "{\"AsciicastEvent\":[0.058985141,\"o\",\"\\u001b[1m\\u001b[3m%\\u001b[23m\\u001b[1m\\u001b[0m                                                                               \\r \\r\"]}";
  let msg2: Message = serde_json::from_str(&msg).unwrap();
  if let Message::AsciicastEvent(ref evt) = msg2 {
    if let EventKind::Output(ref _d) = evt.1 {
      // println!("==> {} <==", String::from_utf8(d.to_vec()).unwrap());
    }
  }
  println!("{msg2:?}");
}
